// File Sat/Assegnazione.java
import java.util.*;
public class Assegnazione implements Cloneable {
    private HashSet<Letterale> di;
    public Assegnazione() {
        di = new HashSet<Letterale>();
    }
    public boolean inserisciLinkDi(Letterale lit) {
        if (lit == null) 
	    return false;
	else 
	    return di.add(lit);
    }
    public boolean eliminaLinkDi(Letterale lit) {
        if (lit == null) 
	    return false;
	else 
	    return di.remove(lit);
    }
    public Set<Letterale> getDi() {
        return (HashSet<Letterale>)di.clone();
    }
    public Object clone() {
        try {
            Assegnazione d = (Assegnazione)super.clone(); 
            d.di = new HashSet<Letterale>();
            Iterator<Letterale> it = getDi().iterator();
            while(it.hasNext()) {
                Letterale elem = it.next();
                d.inserisciLinkDi(elem);
	    }
            return d;
	} catch (CloneNotSupportedException e) {
            // non pu accadere, ma va comunque gestito
            throw new InternalError(e.toString());
        }
    }
    public String toString() {
	String result = new String("(");
	Iterator<Letterale> it = getDi().iterator();
	while(it.hasNext()) {
	    Letterale elem = it.next();
	    result += elem + " ";
	}
	result += ")";
        return result;
    }
}
