// File Sat/Letterale.java

public class Letterale {
    private final boolean segno;
    private final Variabile var;
    public Letterale(Variabile v, boolean s) { 
	var = v; 
	segno = s;
    }
    public Variabile getVariabile() { return var; }
    public boolean getSegno() { return segno; }
    public boolean equals(Object o) {
        if (o != null && getClass().equals(o.getClass())) {
            Letterale l = (Letterale)o;
            return (var.equals(l.var) && segno == l.segno);
        }
        else return false;
    }
    public int hashCode() { 
	return var.hashCode() + (Boolean.valueOf(segno)).hashCode(); 
    }
    public String toString() {
        return (segno?"":"!") + var.getNome();
    }
}

