// File: javaSAT.java
// A simple SAT solver. Reads input in DIMACS format

import java.io.*;
import java.util.*;
public class javaSAT {
private static String time_stamp = 
    "Time-stamp: \"2006-03-24 18:37:52 cadoli\"\n";
    public static void main(String args[]) throws FileNotFoundException {
	if (args.length == 2)
	    Solutori.DEBUG = true;
	String inputFile = args[args.length - 1];
	FormulaCNF cnf = FormulaCNF.leggiDaFileDIMACS(inputFile);
	System.out.print("// This is javaSAT, version of " + 
			   time_stamp);
	System.out.println("// Reading formula from file " + inputFile);
	Assegnazione mod = Solutori.risolviConBacktracking(cnf);
	if (mod != null)
	    System.out.println(cnf + " is SAT\nHere is a model " + mod);
	else
	    System.out.println(cnf + " is UNSAT");
        System.out.println("**************");
    }
}
